<?php

namespace LakeDrops\Component\Composer;

use Composer\Composer;
use Composer\EventDispatcher\EventSubscriberInterface;
use Composer\IO\IOInterface;
use Composer\Plugin\PluginInterface;

/**
 * Composer plugin for handling docker4drupal setup.
 */
abstract class BasePlugin implements BasePluginInterface, PluginInterface, EventSubscriberInterface {

  /**
   * The handler object to do the real work then.
   *
   * @var \LakeDrops\Component\Composer\BaseHandlerInterface
   */
  protected $handler;

  /**
   * {@inheritdoc}
   */
  public function activate(Composer $composer, IOInterface $io) {
    $class = $this->getHandlerClass();
    $this->handler = new $class($composer, $io);
  }

}
